Gecode::Gist::TreeCanvas Class Reference

A canvas that displays the search tree. More...

`#include <treecanvas.hh>`

## Public Slots

void | scaleTree (int scale0, int zoomx=-1, int zoomy=-1)
| Set scale factor to scale0.
void | searchAll (void)
| Explore complete subtree of selected node.
void | searchOne (void)
| Find next solution below selected node.
void | toggleHidden (void)
| Toggle hidden state of selected node.
void | hideFailed (void)
| Hide failed subtrees of selected node.
void | unhideAll (void)
| Unhide all nodes below selected node.
void | toggleStop (void)
| Do not stop at selected stop node.
void | unstopAll (void)
| Do not stop at any stop node.
void | exportPDF (void)
| Export pdf of the current subtree.
void | exportWholeTreePDF (void)
| Export pdf of the whole tree.
void | print (void)
| Print the tree.
void | zoomToFit (void)
| Zoom the canvas so that the whole tree fits.
void | centerCurrentNode (void)
| Center the view on the currently selected node.
void | inspectCurrentNode (bool fix=true, int inspectorNo=-1)
| Call the double click inspector for the currently selected node.
void | inspectBeforeFP (void)
| Calls inspectCurrentNode(false).
void | labelBranches (void)
| Label all branches in subtree under current node.
void | labelPath (void)
| Label all branches on path to root node.
void | stopSearch (void)
| Stop current search.
void | reset (void)
| Reset.
void | navUp (void)
| Move selection to the parent of the selected node.
void | navDown (void)
| Move selection to the first child of the selected node.
void | navLeft (void)
| Move selection to the left sibling of the selected node.
void | navRight (void)
| Move selection to the right sibling of the selected node.
void | navRoot (void)
| Move selection to the root node.
void | navNextSol (bool back=false)
| Move selection to next solution (in DFS order).
void | navPrevSol (void)
| Move selection to previous solution (in DFS order).
void | bookmarkNode (void)
| Bookmark current node.
void | setPath (void)
| Set the current node to be the head of the path.
void | inspectPath (void)
| Call the double click inspector for all nodes on the path from root to head of the path.
void | startCompareNodes (void)
| Wait for click on node to compare with current node.
void | startCompareNodesBeforeFP (void)
| Wait for click on node to compare with current node before fixpoint.
void | emitStatusChanged (void)
| Re-emit status change information for current node.
void | setRecompDistances (int c_d, int a_d)
| Set recomputation distances.
void | setAutoHideFailed (bool b)
| Set preference whether to automatically hide failed subtrees.
void | setAutoZoom (bool b)
| Set preference whether to automatically zoom to fit.
bool | getAutoHideFailed (void)
| Return preference whether to automatically hide failed subtrees.
bool | getAutoZoom (void)
| Return preference whether to automatically zoom to fit.
void | setShowCopies (bool b)
| Set preference whether to show copies in the tree.
bool | getShowCopies (void)
| Return preference whether to show copies in the tree.
void | setRefresh (int i)
| Set refresh rate.
void | setRefreshPause (int i)
| Set refresh pause in msec.
bool | getSmoothScrollAndZoom (void)
| Return preference whether to use smooth scrolling and zooming.
void | setSmoothScrollAndZoom (bool b)
| Set preference whether to use smooth scrolling and zooming.
bool | getMoveDuringSearch (void)
| Return preference whether to move cursor during search.
void | setMoveDuringSearch (bool b)
| Set preference whether to move cursor during search.
void | resizeToOuter (void)
| Resize to the outer widget size if auto zoom is enabled.
bool | finish (void)
| Stop search and wait for it to finish.
void | update (void)
| Update display.
void | scroll (void)
| React to scroll events.
void | layoutDone (int w, int h, int scale0)
| Layout done.
void | setCurrentNode (VisualNode *n, bool finished=true, bool update=true)
| Set the selected node to n.

## Signals

void | scaleChanged (int)
| The scale factor has changed.
void | autoZoomChanged (bool)
| The auto-zoom state was changed.
void | contextMenu (QContextMenuEvent *)
| Context menu triggered.
void | statusChanged (VisualNode *, const Statistics &, bool)
| Status bar update.
void | solution (const Space *)
| Signals that a solution has been found.
void | searchFinished (void)
| Signals that Gist is finished.
void | addedBookmark (const QString &id)
| Signals that a bookmark has been added.
void | removedBookmark (int idx)
| Signals that a bookmark has been removed.

## Public Member Functions

| TreeCanvas (Space *rootSpace, bool bab, QWidget *parent, const Options &opt)
| Constructor.
| ~TreeCanvas (void)
| Destructor.
void | addDoubleClickInspector (Inspector *i)
| Add inspector i.
void | activateDoubleClickInspector (int i, bool active)
| Set active inspector.
void | addSolutionInspector (Inspector *i)
| Add inspector i.
void | activateSolutionInspector (int i, bool active)
| Set active inspector.
void | addMoveInspector (Inspector *i)
| Add inspector i.
void | activateMoveInspector (int i, bool active)
| Set active inspector.
void | addComparator (Comparator *c)
| Add comparator c.
void | activateComparator (int i, bool active)
| Set active comparator.

## Protected Member Functions

VisualNode * | eventNode (QEvent *event)
| Return the node corresponding to the event position.
bool | event (QEvent *event)
| General event handler, used for displaying tool tips.
void | paintEvent (QPaintEvent *event)
| Paint the tree.
void | mousePressEvent (QMouseEvent *event)
| Handle mouse press event.
void | mouseDoubleClickEvent (QMouseEvent *event)
| Handle mouse double click event.
void | contextMenuEvent (QContextMenuEvent *event)
| Handle context menu event.
void | resizeEvent (QResizeEvent *event)
| Handle resize event.
void | wheelEvent (QWheelEvent *event)
| Handle mouse wheel events.
virtual void | timerEvent (QTimerEvent *e)
| Timer invoked for smooth zooming and scrolling.

## Protected Attributes

QMutex | mutex
| Mutex for synchronizing acccess to the tree.
QMutex | layoutMutex
| Mutex for synchronizing layout and drawing.
SearcherThread | searcher
| Search engine thread.
bool | stopSearchFlag
| Flag signalling the search to stop.
bool | finishedFlag
| Flag signalling that Gist is ready to be closed.
Node::NodeAllocator * | na
| Allocator for nodes.
VisualNode * | root
| The root node of the tree.
BestNode * | curBest
| The currently best solution (for branch-and-bound).
VisualNode * | currentNode
| The currently selected node.
VisualNode * | pathHead
| The head of the currently selected path.
QVector< QPair< Inspector *, bool > > | doubleClickInspectors
| The registered click inspectors, and whether they are active.
QVector< QPair< Inspector *, bool > > | solutionInspectors
| The registered solution inspectors, and whether they are active.
QVector< QPair< Inspector *, bool > > | moveInspectors
| The registered move inspectors, and whether they are active.
QVector< QPair< Comparator *, bool > > | comparators
| The registered comparators, and whether they are active.
QVector< VisualNode * > | bookmarks
| The bookmarks map.
bool | compareNodes
| Whether node comparison action is running.
bool | compareNodesBeforeFP
| Whether node comparison action computes fixpoint.
QSlider * | scaleBar
| The scale bar.
Statistics | stats
| Statistics about the search tree.
double | scale
| Current scale factor.
int | xtrans
| Offset on the x axis so that the tree is centered.
bool | autoHideFailed
| Whether to hide failed subtrees automatically.
bool | autoZoom
| Whether to zoom automatically.
bool | showCopies
| Whether to show copies in the tree.
int | refresh
| Refresh rate.
int | refreshPause
| Time (in msec) to pause after each refresh.
bool | smoothScrollAndZoom
| Whether to use smooth scrolling and zooming.
bool | moveDuringSearch
| Whether to move cursor during search.
int | c_d
| The recomputation distance.
int | a_d
| The adaptive recomputation distance.
QTimeLine | zoomTimeLine
| Timer for smooth zooming.
QTimeLine | scrollTimeLine
| Timer for smooth scrolling.
int | targetX
| Target x coordinate after smooth scrolling.
int | sourceX
| Source x coordinate after smooth scrolling.
int | targetY
| Target y coordinate after smooth scrolling.
int | sourceY
| Target y coordinate after smooth scrolling.
int | targetW
| Target width after layout.
int | targetH
| Target height after layout.
int | targetScale
| Target scale after layout.
int | layoutDoneTimerId
| Timer id for delaying the update.

## Detailed Description

A canvas that displays the search tree.

Definition at line 87 of file treecanvas.hh.

## Constructor & Destructor Documentation

## TreeCanvas()

Gecode::Gist::TreeCanvas::TreeCanvas | ( | Space * | rootSpace,
|  | bool | bab,
|  | QWidget * | parent,
|  | const Options & | opt )

Constructor.

Definition at line 52 of file treecanvas.cpp.

## ~TreeCanvas()

Gecode::Gist::TreeCanvas::~TreeCanvas | ( | void |  | ) |

Destructor.

Definition at line 127 of file treecanvas.cpp.

## Member Function Documentation

## addDoubleClickInspector()

void Gecode::Gist::TreeCanvas::addDoubleClickInspector | ( | Inspector * | i | ) |

Add inspector i.

Definition at line 136 of file treecanvas.cpp.

## activateDoubleClickInspector()

void Gecode::Gist::TreeCanvas::activateDoubleClickInspector | ( | int | i,
|  | bool | active )

Set active inspector.

Definition at line 141 of file treecanvas.cpp.

## addSolutionInspector()

void Gecode::Gist::TreeCanvas::addSolutionInspector | ( | Inspector * | i | ) |

Add inspector i.

Definition at line 147 of file treecanvas.cpp.

## activateSolutionInspector()

void Gecode::Gist::TreeCanvas::activateSolutionInspector | ( | int | i,
|  | bool | active )

Set active inspector.

Definition at line 152 of file treecanvas.cpp.

## addMoveInspector()

void Gecode::Gist::TreeCanvas::addMoveInspector | ( | Inspector * | i | ) |

Add inspector i.

Definition at line 158 of file treecanvas.cpp.

## activateMoveInspector()

void Gecode::Gist::TreeCanvas::activateMoveInspector | ( | int | i,
|  | bool | active )

Set active inspector.

Definition at line 163 of file treecanvas.cpp.

## addComparator()

void Gecode::Gist::TreeCanvas::addComparator | ( | Comparator * | c | ) |

Add comparator c.

Definition at line 169 of file treecanvas.cpp.

## activateComparator()

void Gecode::Gist::TreeCanvas::activateComparator | ( | int | i,
|  | bool | active )

Set active comparator.

Definition at line 174 of file treecanvas.cpp.

## scaleTree

void Gecode::Gist::TreeCanvas::scaleTree | ( | int | scale0,
|  | int | zoomx = -1,
|  | int | zoomy = -1 )

slot

Set scale factor to scale0.

Definition at line 180 of file treecanvas.cpp.

## searchAll

void Gecode::Gist::TreeCanvas::searchAll | ( | void |  | ) |

slot

Explore complete subtree of selected node.

Definition at line 449 of file treecanvas.cpp.

## searchOne

void Gecode::Gist::TreeCanvas::searchOne | ( | void |  | ) |

slot

Find next solution below selected node.

Definition at line 455 of file treecanvas.cpp.

## toggleHidden

void Gecode::Gist::TreeCanvas::toggleHidden | ( | void |  | ) |

slot

Toggle hidden state of selected node.

Definition at line 461 of file treecanvas.cpp.

## hideFailed

void Gecode::Gist::TreeCanvas::hideFailed | ( | void |  | ) |

slot

Hide failed subtrees of selected node.

Definition at line 470 of file treecanvas.cpp.

## unhideAll

void Gecode::Gist::TreeCanvas::unhideAll | ( | void |  | ) |

slot

Unhide all nodes below selected node.

Definition at line 479 of file treecanvas.cpp.

## toggleStop

void Gecode::Gist::TreeCanvas::toggleStop | ( | void |  | ) |

slot

Do not stop at selected stop node.

Definition at line 489 of file treecanvas.cpp.

## unstopAll

void Gecode::Gist::TreeCanvas::unstopAll | ( | void |  | ) |

slot

Do not stop at any stop node.

Definition at line 498 of file treecanvas.cpp.

## exportPDF

void Gecode::Gist::TreeCanvas::exportPDF | ( | void |  | ) |

slot

Export pdf of the current subtree.

Definition at line 1064 of file treecanvas.cpp.

## exportWholeTreePDF

void Gecode::Gist::TreeCanvas::exportWholeTreePDF | ( | void |  | ) |

slot

Export pdf of the whole tree.

Definition at line 1057 of file treecanvas.cpp.

## print

void Gecode::Gist::TreeCanvas::print | ( | void |  | ) |

slot

Print the tree.

Definition at line 1071 of file treecanvas.cpp.

## zoomToFit

void Gecode::Gist::TreeCanvas::zoomToFit | ( | void |  | ) |

slot

Zoom the canvas so that the whole tree fits.

Definition at line 528 of file treecanvas.cpp.

## centerCurrentNode

void Gecode::Gist::TreeCanvas::centerCurrentNode | ( | void |  | ) |

slot

Center the view on the currently selected node.

Definition at line 564 of file treecanvas.cpp.

## inspectCurrentNode

void Gecode::Gist::TreeCanvas::inspectCurrentNode | ( | bool | fix = true,
|  | int | inspectorNo = -1 )

slot

Call the double click inspector for the currently selected node.

If fix is true, then the node is inspected after fixpoint computation, otherwise its status after branching but before fixpoint computation is inspected.

Definition at line 618 of file treecanvas.cpp.

## inspectBeforeFP

void Gecode::Gist::TreeCanvas::inspectBeforeFP | ( | void |  | ) |

slot

Calls inspectCurrentNode(false).

Definition at line 754 of file treecanvas.cpp.

## labelBranches

void Gecode::Gist::TreeCanvas::labelBranches | ( | void |  | ) |

slot

Label all branches in subtree under current node.

Definition at line 759 of file treecanvas.cpp.

## labelPath

void Gecode::Gist::TreeCanvas::labelPath | ( | void |  | ) |

slot

Label all branches on path to root node.

Definition at line 767 of file treecanvas.cpp.

## stopSearch

void Gecode::Gist::TreeCanvas::stopSearch | ( | void |  | ) |

slot

Stop current search.

Definition at line 810 of file treecanvas.cpp.

## reset

void Gecode::Gist::TreeCanvas::reset | ( | void |  | ) |

slot

Reset.

Definition at line 816 of file treecanvas.cpp.

## navUp

void Gecode::Gist::TreeCanvas::navUp | ( | void |  | ) |

slot

Move selection to the parent of the selected node.

Definition at line 925 of file treecanvas.cpp.

## navDown

void Gecode::Gist::TreeCanvas::navDown | ( | void |  | ) |

slot

Move selection to the first child of the selected node.

Definition at line 938 of file treecanvas.cpp.

## navLeft

void Gecode::Gist::TreeCanvas::navLeft | ( | void |  | ) |

slot

Move selection to the left sibling of the selected node.

Definition at line 961 of file treecanvas.cpp.

## navRight

void Gecode::Gist::TreeCanvas::navRight | ( | void |  | ) |

slot

Move selection to the right sibling of the selected node.

Definition at line 975 of file treecanvas.cpp.

## navRoot

void Gecode::Gist::TreeCanvas::navRoot | ( | void |  | ) |

slot

Move selection to the root node.

Definition at line 989 of file treecanvas.cpp.

## navNextSol

void Gecode::Gist::TreeCanvas::navNextSol | ( | bool | back = false | ) |

slot

Move selection to next solution (in DFS order).

Definition at line 996 of file treecanvas.cpp.

## navPrevSol

void Gecode::Gist::TreeCanvas::navPrevSol | ( | void |  | ) |

slot

Move selection to previous solution (in DFS order).

Definition at line 1009 of file treecanvas.cpp.

## bookmarkNode

void Gecode::Gist::TreeCanvas::bookmarkNode | ( | void |  | ) |

slot

Bookmark current node.

Definition at line 849 of file treecanvas.cpp.

## setPath

void Gecode::Gist::TreeCanvas::setPath | ( | void |  | ) |

slot

Set the current node to be the head of the path.

Definition at line 874 of file treecanvas.cpp.

## inspectPath

void Gecode::Gist::TreeCanvas::inspectPath | ( | void |  | ) |

slot

Call the double click inspector for all nodes on the path from root to head of the path.

Definition at line 888 of file treecanvas.cpp.

## startCompareNodes

void Gecode::Gist::TreeCanvas::startCompareNodes | ( | void |  | ) |

slot

Wait for click on node to compare with current node.

Definition at line 904 of file treecanvas.cpp.

## startCompareNodesBeforeFP

void Gecode::Gist::TreeCanvas::startCompareNodesBeforeFP | ( | void |  | ) |

slot

Wait for click on node to compare with current node before fixpoint.

Definition at line 912 of file treecanvas.cpp.

## emitStatusChanged

void Gecode::Gist::TreeCanvas::emitStatusChanged | ( | void |  | ) |

slot

Re-emit status change information for current node.

Definition at line 920 of file treecanvas.cpp.

## setRecompDistances

void Gecode::Gist::TreeCanvas::setRecompDistances | ( | int | c_d,
|  | int | a_d )

slot

Set recomputation distances.

Definition at line 1387 of file treecanvas.cpp.

## setAutoHideFailed

void Gecode::Gist::TreeCanvas::setAutoHideFailed | ( | bool | b | ) |

slot

Set preference whether to automatically hide failed subtrees.

Definition at line 1392 of file treecanvas.cpp.

## setAutoZoom

void Gecode::Gist::TreeCanvas::setAutoZoom | ( | bool | b | ) |

slot

Set preference whether to automatically zoom to fit.

Definition at line 1397 of file treecanvas.cpp.

## getAutoHideFailed

bool Gecode::Gist::TreeCanvas::getAutoHideFailed | ( | void |  | ) |

slot

Return preference whether to automatically hide failed subtrees.

Definition at line 1416 of file treecanvas.cpp.

## getAutoZoom

bool Gecode::Gist::TreeCanvas::getAutoZoom | ( | void |  | ) |

slot

Return preference whether to automatically zoom to fit.

Definition at line 1421 of file treecanvas.cpp.

## setShowCopies

void Gecode::Gist::TreeCanvas::setShowCopies | ( | bool | b | ) |

slot

Set preference whether to show copies in the tree.

Definition at line 1407 of file treecanvas.cpp.

## getShowCopies

bool Gecode::Gist::TreeCanvas::getShowCopies | ( | void |  | ) |

slot

Return preference whether to show copies in the tree.

Definition at line 1411 of file treecanvas.cpp.

## setRefresh

void Gecode::Gist::TreeCanvas::setRefresh | ( | int | i | ) |

slot

Set refresh rate.

Definition at line 1426 of file treecanvas.cpp.

## setRefreshPause

void Gecode::Gist::TreeCanvas::setRefreshPause | ( | int | i | ) |

slot

Set refresh pause in msec.

Definition at line 1431 of file treecanvas.cpp.

## getSmoothScrollAndZoom

bool Gecode::Gist::TreeCanvas::getSmoothScrollAndZoom | ( | void |  | ) |

slot

Return preference whether to use smooth scrolling and zooming.

Definition at line 1438 of file treecanvas.cpp.

## setSmoothScrollAndZoom

void Gecode::Gist::TreeCanvas::setSmoothScrollAndZoom | ( | bool | b | ) |

slot

Set preference whether to use smooth scrolling and zooming.

Definition at line 1443 of file treecanvas.cpp.

## getMoveDuringSearch

bool Gecode::Gist::TreeCanvas::getMoveDuringSearch | ( | void |  | ) |

slot

Return preference whether to move cursor during search.

Definition at line 1448 of file treecanvas.cpp.

## setMoveDuringSearch

void Gecode::Gist::TreeCanvas::setMoveDuringSearch | ( | bool | b | ) |

slot

Set preference whether to move cursor during search.

Definition at line 1453 of file treecanvas.cpp.

## resizeToOuter

void Gecode::Gist::TreeCanvas::resizeToOuter | ( | void |  | ) |

slot

Resize to the outer widget size if auto zoom is enabled.

Definition at line 1172 of file treecanvas.cpp.

## finish

bool Gecode::Gist::TreeCanvas::finish | ( | void |  | ) |

slot

Stop search and wait for it to finish.

Definition at line 1276 of file treecanvas.cpp.

## scaleChanged

void Gecode::Gist::TreeCanvas::scaleChanged | ( | int |  | ) |

signal

The scale factor has changed.

## autoZoomChanged

void Gecode::Gist::TreeCanvas::autoZoomChanged | ( | bool |  | ) |

signal

The auto-zoom state was changed.

## contextMenu

void Gecode::Gist::TreeCanvas::contextMenu | ( | QContextMenuEvent * |  | ) |

signal

Context menu triggered.

## statusChanged

void Gecode::Gist::TreeCanvas::statusChanged | ( | VisualNode * | ,
|  | const Statistics & | ,
|  | bool | )

signal

Status bar update.

## solution

void Gecode::Gist::TreeCanvas::solution | ( | const Space * |  | ) |

signal

Signals that a solution has been found.

## searchFinished

void Gecode::Gist::TreeCanvas::searchFinished | ( | void |  | ) |

signal

Signals that Gist is finished.

## addedBookmark

void Gecode::Gist::TreeCanvas::addedBookmark | ( | const QString & | id | ) |

signal

Signals that a bookmark has been added.

## removedBookmark

void Gecode::Gist::TreeCanvas::removedBookmark | ( | int | idx | ) |

signal

Signals that a bookmark has been removed.

## eventNode()

VisualNode * Gecode::Gist::TreeCanvas::eventNode | ( | QEvent * | event | ) |

protected

Return the node corresponding to the event position.

Definition at line 1103 of file treecanvas.cpp.

## event()

bool Gecode::Gist::TreeCanvas::event | ( | QEvent * | event | ) |

protected

General event handler, used for displaying tool tips.

Definition at line 1153 of file treecanvas.cpp.

## paintEvent()

void Gecode::Gist::TreeCanvas::paintEvent | ( | QPaintEvent * | event | ) |

protected

Paint the tree.

Definition at line 1178 of file treecanvas.cpp.

## mousePressEvent()

void Gecode::Gist::TreeCanvas::mousePressEvent | ( | QMouseEvent * | event | ) |

protected

Handle mouse press event.

Definition at line 1328 of file treecanvas.cpp.

## mouseDoubleClickEvent()

void Gecode::Gist::TreeCanvas::mouseDoubleClickEvent | ( | QMouseEvent * | event | ) |

protected

Handle mouse double click event.

Definition at line 1217 of file treecanvas.cpp.

## contextMenuEvent()

void Gecode::Gist::TreeCanvas::contextMenuEvent | ( | QContextMenuEvent * | event | ) |

protected

Handle context menu event.

Definition at line 1234 of file treecanvas.cpp.

## resizeEvent()

void Gecode::Gist::TreeCanvas::resizeEvent | ( | QResizeEvent * | event | ) |

protected

Handle resize event.

Definition at line 1250 of file treecanvas.cpp.

## wheelEvent()

void Gecode::Gist::TreeCanvas::wheelEvent | ( | QWheelEvent * | event | ) |

protected

Handle mouse wheel events.

Definition at line 1264 of file treecanvas.cpp.

## timerEvent()

void Gecode::Gist::TreeCanvas::timerEvent | ( | QTimerEvent * | e | ) |

protected virtual

Timer invoked for smooth zooming and scrolling.

Definition at line 508 of file treecanvas.cpp.

## update

void Gecode::Gist::TreeCanvas::update | ( | void |  | ) |

slot

Update display.

Definition at line 224 of file treecanvas.cpp.

## scroll

void Gecode::Gist::TreeCanvas::scroll | ( | void |  | ) |

slot

React to scroll events.

Definition at line 254 of file treecanvas.cpp.

## layoutDone

void Gecode::Gist::TreeCanvas::layoutDone | ( | int | w,
|  | int | h,
|  | int | scale0 )

slot

Layout done.

Definition at line 259 of file treecanvas.cpp.

## setCurrentNode

void Gecode::Gist::TreeCanvas::setCurrentNode | ( | VisualNode * | n,
|  | bool | finished = true,
|  | bool | update = true )

slot

Set the selected node to n.

Definition at line 1293 of file treecanvas.cpp.

## Member Data Documentation

## mutex

QMutex Gecode::Gist::TreeCanvas::mutex

protected

Mutex for synchronizing acccess to the tree.

Definition at line 246 of file treecanvas.hh.

## layoutMutex

QMutex Gecode::Gist::TreeCanvas::layoutMutex

protected

Mutex for synchronizing layout and drawing.

Definition at line 248 of file treecanvas.hh.

## searcher

SearcherThread Gecode::Gist::TreeCanvas::searcher

protected

Search engine thread.

Definition at line 250 of file treecanvas.hh.

## stopSearchFlag

bool Gecode::Gist::TreeCanvas::stopSearchFlag

protected

Flag signalling the search to stop.

Definition at line 252 of file treecanvas.hh.

## finishedFlag

bool Gecode::Gist::TreeCanvas::finishedFlag

protected

Flag signalling that Gist is ready to be closed.

Definition at line 254 of file treecanvas.hh.

## na

Node::NodeAllocator* Gecode::Gist::TreeCanvas::na

protected

Allocator for nodes.

Definition at line 256 of file treecanvas.hh.

## root

VisualNode* Gecode::Gist::TreeCanvas::root

protected

The root node of the tree.

Definition at line 258 of file treecanvas.hh.

## curBest

BestNode* Gecode::Gist::TreeCanvas::curBest

protected

The currently best solution (for branch-and-bound).

Definition at line 260 of file treecanvas.hh.

## currentNode

VisualNode* Gecode::Gist::TreeCanvas::currentNode

protected

The currently selected node.

Definition at line 262 of file treecanvas.hh.

## pathHead

VisualNode* Gecode::Gist::TreeCanvas::pathHead

protected

The head of the currently selected path.

Definition at line 264 of file treecanvas.hh.

## doubleClickInspectors

QVector<QPair<Inspector*,bool> > Gecode::Gist::TreeCanvas::doubleClickInspectors

protected

The registered click inspectors, and whether they are active.

Definition at line 266 of file treecanvas.hh.

## solutionInspectors

QVector<QPair<Inspector*,bool> > Gecode::Gist::TreeCanvas::solutionInspectors

protected

The registered solution inspectors, and whether they are active.

Definition at line 268 of file treecanvas.hh.

## moveInspectors

QVector<QPair<Inspector*,bool> > Gecode::Gist::TreeCanvas::moveInspectors

protected

The registered move inspectors, and whether they are active.

Definition at line 270 of file treecanvas.hh.

## comparators

QVector<QPair<Comparator*,bool> > Gecode::Gist::TreeCanvas::comparators

protected

The registered comparators, and whether they are active.

Definition at line 272 of file treecanvas.hh.

## bookmarks

QVector<VisualNode*> Gecode::Gist::TreeCanvas::bookmarks

protected

The bookmarks map.

Definition at line 275 of file treecanvas.hh.

## compareNodes

bool Gecode::Gist::TreeCanvas::compareNodes

protected

Whether node comparison action is running.

Definition at line 278 of file treecanvas.hh.

## compareNodesBeforeFP

bool Gecode::Gist::TreeCanvas::compareNodesBeforeFP

protected

Whether node comparison action computes fixpoint.

Definition at line 280 of file treecanvas.hh.

## scaleBar

QSlider* Gecode::Gist::TreeCanvas::scaleBar

protected

The scale bar.

Definition at line 283 of file treecanvas.hh.

## stats

Statistics Gecode::Gist::TreeCanvas::stats

protected

Statistics about the search tree.

Definition at line 286 of file treecanvas.hh.

## scale

double Gecode::Gist::TreeCanvas::scale

protected

Current scale factor.

Definition at line 289 of file treecanvas.hh.

## xtrans

int Gecode::Gist::TreeCanvas::xtrans

protected

Offset on the x axis so that the tree is centered.

Definition at line 291 of file treecanvas.hh.

## autoHideFailed

bool Gecode::Gist::TreeCanvas::autoHideFailed

protected

Whether to hide failed subtrees automatically.

Definition at line 294 of file treecanvas.hh.

## autoZoom

bool Gecode::Gist::TreeCanvas::autoZoom

protected

Whether to zoom automatically.

Definition at line 296 of file treecanvas.hh.

## showCopies

bool Gecode::Gist::TreeCanvas::showCopies

protected

Whether to show copies in the tree.

Definition at line 298 of file treecanvas.hh.

## refresh

int Gecode::Gist::TreeCanvas::refresh

protected

Refresh rate.

Definition at line 300 of file treecanvas.hh.

## refreshPause

int Gecode::Gist::TreeCanvas::refreshPause

protected

Time (in msec) to pause after each refresh.

Definition at line 302 of file treecanvas.hh.

## smoothScrollAndZoom

bool Gecode::Gist::TreeCanvas::smoothScrollAndZoom

protected

Whether to use smooth scrolling and zooming.

Definition at line 304 of file treecanvas.hh.

## moveDuringSearch

bool Gecode::Gist::TreeCanvas::moveDuringSearch

protected

Whether to move cursor during search.

Definition at line 306 of file treecanvas.hh.

## c_d

int Gecode::Gist::TreeCanvas::c_d

protected

The recomputation distance.

Definition at line 309 of file treecanvas.hh.

## a_d

int Gecode::Gist::TreeCanvas::a_d

protected

The adaptive recomputation distance.

Definition at line 311 of file treecanvas.hh.

## zoomTimeLine

QTimeLine Gecode::Gist::TreeCanvas::zoomTimeLine

protected

Timer for smooth zooming.

Definition at line 331 of file treecanvas.hh.

## scrollTimeLine

QTimeLine Gecode::Gist::TreeCanvas::scrollTimeLine

protected

Timer for smooth scrolling.

Definition at line 333 of file treecanvas.hh.

## targetX

int Gecode::Gist::TreeCanvas::targetX

protected

Target x coordinate after smooth scrolling.

Definition at line 335 of file treecanvas.hh.

## sourceX

int Gecode::Gist::TreeCanvas::sourceX

protected

Source x coordinate after smooth scrolling.

Definition at line 337 of file treecanvas.hh.

## targetY

int Gecode::Gist::TreeCanvas::targetY

protected

Target y coordinate after smooth scrolling.

Definition at line 339 of file treecanvas.hh.

## sourceY

int Gecode::Gist::TreeCanvas::sourceY

protected

Target y coordinate after smooth scrolling.

Definition at line 341 of file treecanvas.hh.

## targetW

int Gecode::Gist::TreeCanvas::targetW

protected

Target width after layout.

Definition at line 344 of file treecanvas.hh.

## targetH

int Gecode::Gist::TreeCanvas::targetH

protected

Target height after layout.

Definition at line 346 of file treecanvas.hh.

## targetScale

int Gecode::Gist::TreeCanvas::targetScale

protected

Target scale after layout.

Definition at line 348 of file treecanvas.hh.

## layoutDoneTimerId

int Gecode::Gist::TreeCanvas::layoutDoneTimerId

protected

Timer id for delaying the update.

Definition at line 350 of file treecanvas.hh.

The documentation for this class was generated from the following files:

- gecode/gist/treecanvas.hh
- gecode/gist/treecanvas.cpp